質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

新規登録して質問してみよう
ただいま回答率
86.02%
Namespace

各要素の名前の重複による衝突が起こらないよう、一意の名前をつけなければならない範囲のことであり、また、プログラミングにおける識別名を付加する機能のをNamespace(名前空間)と呼ぶ。

PHP

PHPは、Webサイト構築に特化して開発されたプログラミング言語です。大きな特徴のひとつは、HTMLに直接プログラムを埋め込むことができるという点です。PHPを用いることで、HTMLを動的コンテンツとして出力できます。HTMLがそのままブラウザに表示されるのに対し、PHPプログラムはサーバ側で実行された結果がブラウザに表示されるため、PHPスクリプトは「サーバサイドスクリプト」と呼ばれています。

Q&A

解決済

例外処理で名前空間を使うとClass not foundになってしまう

kayabacho
kayabacho

総合スコア11

Namespace

各要素の名前の重複による衝突が起こらないよう、一意の名前をつけなければならない範囲のことであり、また、プログラミングにおける識別名を付加する機能のをNamespace(名前空間)と呼ぶ。

PHP

PHPは、Webサイト構築に特化して開発されたプログラミング言語です。大きな特徴のひとつは、HTMLに直接プログラムを埋め込むことができるという点です。PHPを用いることで、HTMLを動的コンテンツとして出力できます。HTMLがそのままブラウザに表示されるのに対し、PHPプログラムはサーバ側で実行された結果がブラウザに表示されるため、PHPスクリプトは「サーバサイドスクリプト」と呼ばれています。

1回答

0グッド

0クリップ

1595閲覧

投稿2020/05/15 06:53

前提・実現したいこと

こんにちは今月からPHP習得ものです。
例外処理のサンプルコードを作成しておりまして、namespaceを定義すると以下のようなエラーメッセージが出てきます。
何故、namespaceを使うとclassの'My\Number\Exception'がnot foundになってしまうのか理由がよく理解できず、困っております。
初投稿で至らぬ部分があれば申し訳ございませんが、先輩エンジニアの方々からご教授頂きたく思っています。
宜しくお願い致します。

発生している問題・エラーメッセージ

3PHP Fatal error: Uncaught Error: Class 'My\Number\Exception' not found in /home/runner/StimulatingTemptingHertz/main.php:8 Stack trace: #0 /home/runner/StimulatingTemptingHertz/main.php(17): My\Number\num(1, 0) #1 {main} thrown in /home/runner/StimulatingTemptingHertz/main.php on line 8

該当のソースコード

<?php namespace My\Number; function num($a, $b) { try { if ($b === 0) { throw new Exception("can not add"); } echo $a + $b; } catch (Exception $e) { echo $e->getMessage(); } } num(1, 2); num(1, 0);

試したこと

クラスとcatchのExceptionにエスケープを付けるとプログラム自体は動きました。

補足情報(FW/ツールのバージョンなど)

PHP 7.0.33

です。宜しくお願い致します。

以下のような質問にはグッドを送りましょう

  • 質問内容が明確
  • 自分も答えを知りたい
  • 質問者以外のユーザにも役立つ

グッドが多くついた質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

気になる質問をクリップする

クリップした質問は、後からいつでもマイページで確認できます。

またクリップした質問に回答があった際、通知やメールを受け取ることができます。

下記のような質問は推奨されていません。

  • 間違っている
  • 質問になっていない投稿
  • スパムや攻撃的な表現を用いた投稿

適切な質問に修正を依頼しましょう。

回答1

0

ベストアンサー

クラスとcatchのExceptionにエスケープを付けると

あれは「エスケープ」ではありません。名前空間の区切りに使うものと同じで、完全修飾名と言う表現です。

グローバルなクラス、関数あるいは定数にアクセスするには、完全修飾名を使用して \strlen()、\Exception あるいは \INI_ALL などとすることができます。

投稿2020/05/15 07:10

編集2020/05/15 07:10
m.ts10806

総合スコア80030

良いと思った回答にはグッドを送りましょう。
グッドが多くついた回答ほどページの上位に表示されるので、他の人が素晴らしい回答を見つけやすくなります。

下記のような回答は推奨されていません。

  • 間違っている回答
  • 質問の回答になっていない投稿
  • スパムや攻撃的な表現を用いた投稿

このような回答には修正を依頼しましょう。

回答へのコメント

kayabacho

2020/05/15 07:17

コメント有難う御座います。 完全修飾名というのですか。知らなかったです。 どうして完全修飾名をExceptionに付加するとプログラムが動くのでしょうか?
m.ts10806

2020/05/15 07:40

もう少しマニュアルを読んでいけば理解できるかと思いますが、namespaceを宣言するとプログラム内の情報全てが「その名前空間の管理下」に置かれます。 特にクラスはその影響をもろにうけます。 Exceptionもクラス(基底クラス)ですので、冒頭になにもつけられてないということで、My\Number\内を探そうとします。 冒頭に\をつけることで「ルートの」と解釈され、基底クラスを見に行けるようになります。 まあ「絶対パス」と言ってもいいかもしれませんね。
kayabacho

2020/05/15 08:35 編集

自分もその指定したプログラム内全てが名前空間の管理下という認識ですが、My\Number\内を探すのであれば、名前空間の管理下にあるExceptionまで無事にいきつくのではないでしょうか? それとも、My\Number\はその段階では何もまだ定義されてないということなのでしょうか。
m.ts10806

2020/05/15 08:36

My\Number\ 配下にExceptionクラスを定義してるわけではないですよね。
kayabacho

2020/05/15 08:52

仰る通り、配下に定義はしているつもりはないです。 なるほど。My\Numberを探しに行ってもクラスが配下にあるわけでは無いからClass'......''My\Number\Exception' not foundのエラー文が出てきてしまうのですね。
m.ts10806

2020/05/15 09:00

はい。なにも冒頭にないものはその配下のものと解釈されます。でも存在しないからnot foundになると
kayabacho

2020/05/15 09:04

なるほど。スッキリしました。 有難う御座います。

15分調べてもわからないことは
teratailで質問しよう!

ただいまの回答率
86.02%

質問をまとめることで
思考を整理して素早く解決

テンプレート機能で
簡単に質問をまとめる

質問する

関連した質問

同じタグがついた質問を見る

Namespace

各要素の名前の重複による衝突が起こらないよう、一意の名前をつけなければならない範囲のことであり、また、プログラミングにおける識別名を付加する機能のをNamespace(名前空間)と呼ぶ。

PHP

PHPは、Webサイト構築に特化して開発されたプログラミング言語です。大きな特徴のひとつは、HTMLに直接プログラムを埋め込むことができるという点です。PHPを用いることで、HTMLを動的コンテンツとして出力できます。HTMLがそのままブラウザに表示されるのに対し、PHPプログラムはサーバ側で実行された結果がブラウザに表示されるため、PHPスクリプトは「サーバサイドスクリプト」と呼ばれています。